=== debian/changelog ===
ros-melodic-rslidar-sdk (1.3.2-1bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- robosense <zdxiao@robosense.cn>  Wed, 09 Mar 2022 11:47:35 -0000
